		ld a,$F2
		call SendSafeByte ; Send "identify" byte
		jp nz,nodevice
		call GetByte ; Get back ID
		jp nz,nodevice

keyboard:
		; Will return AB83 if keyboard
		cp $AB
		jr nz,mouse ; If it doesn't start with $AB, perhaps it's a mouse?
		call SafeDelay
		call GetByte
		jp nz,nodevice
		cp $83
		jr nz,unknowndevice ; If it's $AB but not $83, who knows what it is?
		ld a,1 ; If it is, we can return 1
		jp finish
		
mouse:
		cp 3
		jr z,intellimouse ; If it's 3, then we already know it's an Intellimouse.
		or a ; CP 0
		jr nz,unknowndevice ; If it's not zero, then what is it?
		; If it is zero, it could still be an Intellimouse.

		; Check for "Intellimouse"
		; Send F3C8F364F350F2
		ld a,$C8
		call sendrate
		ld a,$64
		call sendrate
		ld a,$50
		call sendrate

		ld a,$F2
		call SendSafeByte
		jp nz,nodevice
		call GetByte ; Get response
		or a ;CP 0
		jr z,normalmouse ; Zero means normal mouse.

intellimouse:
		ld a,3 ; Return 3 for Intellimouse
		jp finish

normalmouse:
		ld a,2 ; Return 2 for normal mouse
		jp finish

unknowndevice:
		ld a,4 ; Return 4 for unknown
		jp finish

sendrate: ; This just sends $F3 and then A.
		push af
		ld a,$F3
		call SendSafeByte
		jp nz,poperror ; Pop PC off the stack if we have to get out here
		pop af
		call SendSafeByte
		jp nz,poperror
		ret