#define buffer AppBackupScreen ; Scrap ram...

		res 0,(iy+asm_flag1) ; Clear shift
keyuploop:
		ld a,'_'
		b_call(_putmap) ; Display cursor
		call getnextevent ; Wait for next event
		or a ; CP 0
		jr z,notup ; If flag A is zero, then they event is not a "key up"
		ld de,$12
		b_call(_cphlde) ; See if it's shift
		jr z,letupshift
		ld de,$59
		jp nz,keyuploop
letupshift:
		res 0,(iy+asm_flag1) ; If it is, then clear shift flag, because shift was let up
		jp keyuploop

notup:
		ld de,$E05A ; numpad enter
		b_call(_cphlde)
		jp z,done ; Finish if they pushed Enter
		ld de,$E04A ; numpad /
		b_call(_cphlde)
		jr nz,onebytecodes
		ld h,0 ; If it's numpad /, erase the first byte, because it behaves the same as normal /
onebytecodes:
		ld a,h
		or a ; CP 0
		jr nz,keyuploop ; We don't care about 2-byte keys
		ld a,l ; A is now scan code

		cp $AA ; Init code
		jr z,keyuploop
		cp $5A ; Enter
		jp z,done

		cp $66 ; Backspace
		jr nz,checkshiftdown
		;Error checking:
		ld hl,cursorpos
		ld a,(hl)
		or a
		jr z,keyuploop ; Return if the cursor position is zero
		dec (hl) ; Otherwise, decrease it
		;Display:
		ld a,' '
		b_call(_putmap) ; Erase the cursor _
		;Buffer:
		ld a,(bufferpos)
		ld e,a
		ld d,0
		ld hl,buffer
		add hl,de
		ex de,hl ; HL is now the cursor buffer position in memory
		ld hl,bufferpos
		dec (hl) ; Decrement buffer position
		dec de
		dec de ; Go back 2 bytes in buffer
		ld a,(de)
		cp $BB
		jr nz,cursorback ; If it's a 2-byte token, 
		dec (hl) ; Decrement the buffer position another byte
cursorback:
		;Cursor		
		ld hl,curcol
		dec (hl) ; Decrement column
		jp p,keyuploop ; If it stayed positive, we're done here
		ld (hl),15
		ld hl,currow ; Otherwise, set the column to 15
		dec (hl) ; And decrease the row.
		jr keyuploop

checkshiftdown: ; Shift key pressed
		cp $12
		jr z,shift
		cp $59
		jr nz,normalchar
shift:
		set 0,(iy+asm_flag1) ; Set shift flag if shift was pressed
		jp keyuploop

normalchar: ; Normal character
		;Error Checking
		ld hl,(currow)
		ld de,$0F07
		b_call(_cphlde)
		jp z,keyuploop ; Return if cursor is at bottom-right
		;Display
		ld d,0
		ld e,a ; DE=A
		bit 0,(iy+asm_flag1) ; Check to see if shift is currently pressed
		jr z,normal
		ld hl,shiftkeys ; If it is, load in the shift character codes
		jr showkey
normal:
		ld hl,normalkeys ; Otherwise, just use the normal ones
showkey:
		add hl,de ; Add the offset to the table
		ld a,(hl) ; And load the character into A
		or a ; CP 0
		jp z,keyuploop ; If the char is zero, don't bother displaying it.
		b_call(_putmap) ; Otherwise, do.
		;Buffer
		bit 0,(iy+asm_flag1) ; Again, check the shift flag and set tables accordingly
		jr z,normaltoken
		ld hl,shifttokens
		jr addtoken
normaltoken:
		ld hl,normaltokens
addtoken:
		add hl,de
		add hl,de ; Twice, because token table is 2 bytes per entry
		ld e,(hl)
		inc hl
		ld d,(hl) ; Load token into DE little-endian style
		ex de,hl ; Token is now in HL
		call addtobuffer ; Add it to the buffer
		;Cursor
		ld hl,cursorpos
		inc (hl) ; Increment cursor position
		ld a,(curcol)
		inc a
		cp 16
		jr nz,easy_back ; If incrementing didn't made the current column go to 16, then load it back in and finish
		ld hl,currow ; Otherwise...
		inc (hl) ; Increment the current row
		xor a ; LD A,0
easy_back: ; Load and finish.
		ld (curcol),a
		jp keyuploop

done: ; When they push enter
		ld a,' '
		b_call(_putmap) ; Clear the cursor _
		b_call(_newline) ; Move to the next line, just like BASIC's Input
		ld hl,0
		call addtobuffer ; Zero-terminate the buffer
		b_call(_ansname)
		b_call(_findsym)
		jr c,novarfound
		b_call(_delvar) ; Delete Ans if it exists
novarfound:
		ld hl,ansstring
		b_call(_mov9toop1) ; OP1=Ans as string
		ld a,(bufferpos)
		dec a ; Subtract one from the buffer size, because of null-termination
		ld l,a
		ld h,0 ; Buffer position - 1 is string size
		b_call(_createstrng) ; So make the string
		inc de
		inc de ; Get past size bytes
		ld hl,buffer
		b_call(_strcopy) ; Copy the buffer into string Ans
		ret ; LEAVE

cursorpos: ; The current position of the cursor, not counting line breaks
		.db 0
bufferpos: ; The current position in the buffer, counting 2-byte tokens
		.db 0
ansstring: ; The name of Ans if it were a string
		.db strngobj,tans,0,0
	
addtobuffer:
		push hl
		ld hl,buffer
		ld a,(bufferpos)
		ld e,a
		ld d,0 ; DE=buffer position
		add hl,de ; Get memory location in buffer
		pop bc ; Was passed in as HL
		ex de,hl ; DE=memory location in buffer
		ld hl,bufferpos
		ld a,b
		or a ; CP 0
		jr z,onebytetok ; If it's a one-byte token (first byte is $00) then jump
		ld (de),a ; Otherwise, load the MSB into the buffer
		inc de ; And increment the current buffer memory location
		inc (hl) ; And increment the buffer position counter
onebytetok:
		ld a,c ; LSB into A
		ld (de),a ; Load it into buffer
		inc (hl) ; Increment buffer position counter (2nd time if 2-byte token, 1st time if 1-byte token)
		ret
