; TICI Hub TI-BASIC library
; By Eric Van Albet
; with code from Ben Ryves/MaxCoderz

.nolist
#include "ti83plus.inc"
#define progstart $9D95
.list
.org progstart-2
		.db t2ByteTok,tAsmCmp

#include "init_routines.asm" ; Initialization code

getstatus: ; Function 0: Gets current device. 0=nothing, 1=keyboard, 2=normal mouse, 3=intellimouse, 4=unknown
		or a ;CP 0
		jr nz,setlights
		#include "getstatus.asm"

setlights: ; Functions 1-8: Turns on/off keyboard lights, 8=all off. 1 on success, 0 on failure
		cp 9
		jr nc,getnextkey ; >=9
		#include "setlights.asm"

getnextkey: ; Function 9: Gets the next key press. Scan code on success, 0 on failure
		cp 9
		jr nz,stringinput
		#include "getnextkey.asm"

stringinput: ; Function 10: Inputs a string from the keyboard. Returns string inputted.
		cp 10
		ret nz
		#include "stringinput.asm"

#include "keyboard_routines.asm" ; Routines for keyboard input

#include "finish_routines.asm" ; Routines for exiting out of the program

#include "ps2.asm" ; PS/2 communication routines
#include "keyboard_layout.asm" ; Lookup table: Scan Code > Character Code or Scan Code > Token

.end